Index: trunk/src/lib/gui/gl_gui/glgui_widget.cc
===================================================================
--- trunk/src/lib/gui/gl_gui/glgui_widget.cc	(revision 6430)
+++ trunk/src/lib/gui/gl_gui/glgui_widget.cc	(revision 6431)
@@ -107,4 +107,9 @@
 }
 
+void GLGuiWidget::hide()
+{
+  this->setVisibility(false);
+}
+
 
 void GLGuiWidget::draw() const
Index: trunk/src/lib/gui/gl_gui/glgui_widget.h
===================================================================
--- trunk/src/lib/gui/gl_gui/glgui_widget.h	(revision 6430)
+++ trunk/src/lib/gui/gl_gui/glgui_widget.h	(revision 6431)
@@ -50,5 +50,5 @@
 
     void show();
-    void hide() {};
+    void hide();
 
     void connectSignal(GLGuiSignalType signalType, const Executor& signal);
Index: trunk/src/world_entities/weapons/bomb.cc
===================================================================
--- trunk/src/world_entities/weapons/bomb.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/bomb.cc	(revision 6431)
@@ -46,6 +46,7 @@
   this->loadModel("models/projectiles/RadioActiveBomb.obj", 1.0);
 
-  this->energyMin = 1;
-  this->energyMax = 1;
+  this->setMinEnergy(1);
+  this->setMaxEnergy(10);
+
   this->lifeSpan = 15;
 
Index: trunk/src/world_entities/weapons/guided_missile.cc
===================================================================
--- trunk/src/world_entities/weapons/guided_missile.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/guided_missile.cc	(revision 6431)
@@ -41,6 +41,6 @@
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
 
-  this->energyMin = 1;
-  this->energyMax = 10;
+  this->setMinEnergy(1);
+  this->setMaxEnergy(10);
   this->lifeSpan = 10.0;
   this->agility = 500;
@@ -146,5 +146,5 @@
 {
 
-  
+
 if (this->target != NULL && this->target->getParent() != PNode::getNullParent())
    {
Index: trunk/src/world_entities/weapons/laser.cc
===================================================================
--- trunk/src/world_entities/weapons/laser.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/laser.cc	(revision 6431)
@@ -42,6 +42,6 @@
   this->loadModel("models/projectiles/laser.obj");
 
-  this->energyMin = 1;
-  this->energyMax = 10;
+  this->setMinEnergy(1);
+  this->setMaxEnergy(10);
   this->lifeSpan = 5.0;
 
Index: trunk/src/world_entities/weapons/projectile.cc
===================================================================
--- trunk/src/world_entities/weapons/projectile.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/projectile.cc	(revision 6431)
@@ -53,17 +53,7 @@
 
 
-void Projectile::setEnergies(float energyMin, float energyMax)
+void Projectile::setMinEnergy(float energyMin)
 {
   this->energyMin = energyMin;
-  if (energyMax <= energyMin)
-  {
-    this->bChargeable = false;
-    this->energyMax = energyMin;
-  }
-  else
-  {
-    this->bChargeable = true;
-    this->energyMax = energyMax;
-  }
 }
 
Index: trunk/src/world_entities/weapons/projectile.h
===================================================================
--- trunk/src/world_entities/weapons/projectile.h	(revision 6430)
+++ trunk/src/world_entities/weapons/projectile.h	(revision 6431)
@@ -23,9 +23,7 @@
 
 
-    void setEnergies(float energyMin, float energyMax);
+    void setMinEnergy(float energyMin);
     /** @returns the minimal charched energy */
-    inline float getEnergyMin() { return this->energyMin; };
-    /** @returns the maximal charched energy */
-    inline float getEnergyMax() { return this->energyMax; };
+    inline float getMinEnergy() { return this->energyMin; };
     /** @returns if the Projectile can be charged */
     inline bool isChageable() { return this->bChargeable; };
@@ -50,5 +48,4 @@
     // energy
     float                 energyMin;                 //!< The minimal Energy a Projectile needs to be emitted.
-    float                 energyMax;                 //!< The maximal Energy a Projectile can take, before being emitted.
     bool                  bChargeable;               //!< if the Projectile is Charegeable
 
Index: trunk/src/world_entities/weapons/rocket.cc
===================================================================
--- trunk/src/world_entities/weapons/rocket.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/rocket.cc	(revision 6431)
@@ -42,6 +42,6 @@
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
 
-  this->energyMin = 1;
-  this->energyMax = 10;
+  this->setMinEnergy(1);
+  this->setMaxEnergy(10);
   this->lifeSpan = 5;
 
Index: trunk/src/world_entities/weapons/test_bullet.cc
===================================================================
--- trunk/src/world_entities/weapons/test_bullet.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/test_bullet.cc	(revision 6431)
@@ -42,6 +42,6 @@
   this->loadModel("models/projectiles/orx-rocket.obj", .3);
 
-  this->energyMin = 1;
-  this->energyMax = 10;
+  this->setMinEnergy(1);
+  this->setMaxEnergy(10);
   this->lifeSpan = 2;
 
Index: trunk/src/world_entities/weapons/weapon.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon.cc	(revision 6430)
+++ trunk/src/world_entities/weapons/weapon.cc	(revision 6431)
@@ -144,6 +144,6 @@
     // grabbing Parameters from the Projectile to have them at hand here.
     Projectile* pj = dynamic_cast<Projectile*>(this->projectileFactory->resurrect());
-    this->minCharge = pj->getEnergyMin();
-    this->maxCharge = pj->getEnergyMax();
+    this->minCharge = pj->getMinEnergy();
+    this->maxCharge = pj->getMaxEnergy();
     this->chargeable = pj->isChageable();
     this->projectileFactory->kill(pj);
Index: trunk/src/world_entities/world_entity.cc
===================================================================
--- trunk/src/world_entities/world_entity.cc	(revision 6430)
+++ trunk/src/world_entities/world_entity.cc	(revision 6431)
@@ -391,4 +391,9 @@
 }
 
+/**
+ * @brief creates the EnergyWidget
+ *
+ * since not all entities need an EnergyWidget, it is only created on request.
+ */
 void WorldEntity::createEnergyWidget()
 {
@@ -397,5 +402,5 @@
     this->energyWidget = new GLGuiBar();
     this->energyWidget->setSize2D(30,400);
-    this->energyWidget->setAbsCoor2D(5,100);
+    this->energyWidget->setAbsCoor2D(10,100);
 
     this->updateEnergyWidget();
@@ -405,4 +410,8 @@
 }
 
+/**
+ * @param visibility shows or hides the energy-bar
+ * (creates the widget if needed)
+ */
 void WorldEntity::setEnergyWidgetVisibilit(bool visibility)
 {
@@ -422,4 +431,7 @@
 }
 
+/**
+ * @brief updates the EnergyWidget
+ */
 void WorldEntity::updateEnergyWidget()
 {