Index: trunk/src/story_entities/game_world.cc
===================================================================
--- trunk/src/story_entities/game_world.cc	(revision 6432)
+++ trunk/src/story_entities/game_world.cc	(revision 6433)
@@ -330,4 +330,5 @@
     this->tick(this->dataTank->objectManager->getObjectList(OM_COMMON), this->dtS);
     this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_00), this->dtS);
+    this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_00_PROJ), this->dtS);
     this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_01), this->dtS);
     this->tick(this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ), this->dtS);
@@ -366,5 +367,8 @@
 {
   CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_00),
-      this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
+  this->dataTank->objectManager->getObjectList(OM_GROUP_01_PROJ));
+  CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
+  this->dataTank->objectManager->getObjectList(OM_GROUP_00_PROJ));
+
   CDEngine::getInstance()->checkCollisions(this->dataTank->objectManager->getObjectList(OM_GROUP_01),
       this->dataTank->objectManager->getObjectList(OM_COMMON));
@@ -405,4 +409,5 @@
   engine->draw(State::getObjectManager()->getObjectList(OM_COMMON));
   engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_00));
+  engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_00_PROJ));
   engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_01));
   engine->draw(State::getObjectManager()->getObjectList(OM_GROUP_01_PROJ));
Index: trunk/src/world_entities/npcs/ground_turret.cc
===================================================================
--- trunk/src/world_entities/npcs/ground_turret.cc	(revision 6432)
+++ trunk/src/world_entities/npcs/ground_turret.cc	(revision 6433)
@@ -92,4 +92,5 @@
     this->left->toList(this->getOMListNumber());
     this->left->setRelCoor(0,10,-5);
+    this->left->requestAction( WA_ACTIVATE);
   }
 
@@ -102,4 +103,5 @@
     this->right->toList(this->getOMListNumber());
     this->right->setRelCoor(0,10,5);
+    this->left->requestAction( WA_ACTIVATE);
   }
 }
@@ -109,6 +111,16 @@
  * @param time the Time to step
  */
-void GroundTurret::tick(float time)
-{
+void GroundTurret::tick(float dt)
+{
+  if (likely(this->left != NULL))
+  {
+    this->left->tickW(dt);
+    this->left->requestAction(WA_SHOOT);
+  }
+  if (likely(this->right != NULL))
+  {
+    this->right->tickW(dt);
+    this->right->requestAction(WA_SHOOT);
+  }
 
 }
Index: trunk/src/world_entities/weapons/guided_missile.cc
===================================================================
--- trunk/src/world_entities/weapons/guided_missile.cc	(revision 6432)
+++ trunk/src/world_entities/weapons/guided_missile.cc	(revision 6433)
@@ -134,5 +134,5 @@
 void GuidedMissile::collidesWith(WorldEntity* entity, const Vector& location)
 {
-  if (this->hitEntity != entity && entity->isA(CL_NPC))
+  if (this->hitEntity != entity)
     this->destroy();
   this->hitEntity = entity;
Index: trunk/src/world_entities/weapons/rocket.cc
===================================================================
--- trunk/src/world_entities/weapons/rocket.cc	(revision 6432)
+++ trunk/src/world_entities/weapons/rocket.cc	(revision 6433)
@@ -132,5 +132,5 @@
 void Rocket::collidesWith(WorldEntity* entity, const Vector& location)
 {
-  if (this->hitEntity != entity && entity->isA(CL_NPC))
+  if (this->hitEntity != entity)
     this->destroy();
   this->hitEntity = entity;
Index: trunk/src/world_entities/weapons/weapon.cc
===================================================================
--- trunk/src/world_entities/weapons/weapon.cc	(revision 6432)
+++ trunk/src/world_entities/weapons/weapon.cc	(revision 6433)
@@ -373,5 +373,5 @@
 //  if (this->currentState == WS_INACTIVE)
   {
-        // play Sound
+    // play Sound
     if (likely(this->soundBuffers[WA_ACTIVATE] != NULL))
       this->soundSource->play(this->soundBuffers[WA_ACTIVATE]);
@@ -564,6 +564,6 @@
 void Weapon::debug() const
 {
-  PRINT(3)("Weapon-Debug %s, state: %s, nextAction: %s\n", this->getName(), Weapon::stateToChar(this->currentState), Weapon::actionToChar(requestedAction));
-  PRINT(3)("Energy: max: %f; current: %f;  loadedMax: %f; loadedCurrent: %f; chargeMin: %f, chargeMax %f\n",
+  PRINT(0)("Weapon-Debug %s, state: %s (duration: %fs), nextAction: %s\n", this->getName(), Weapon::stateToChar(this->currentState), this->stateDuration, Weapon::actionToChar(requestedAction));
+  PRINT(0)("Energy: max: %f; current: %f;  loadedMax: %f; loadedCurrent: %f; chargeMin: %f, chargeMax %f\n",
             this->energyMax, this->energy, this->energyLoadedMax, this->energyLoaded, this->minCharge, this->maxCharge);
 