Index: /code/branches/sound4/src/orxonox/sound/AmbientSound.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/AmbientSound.h	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/AmbientSound.h	(revision 6435)
@@ -31,5 +31,5 @@
 #define _AmbientSound_H__
 
-#include "OrxonoxPrereqs.h"
+#include "sound/SoundPrereqs.h"
 
 #include "core/BaseObject.h"
Index: /code/branches/sound4/src/orxonox/sound/BaseSound.cc
===================================================================
--- /code/branches/sound4/src/orxonox/sound/BaseSound.cc	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/BaseSound.cc	(revision 6435)
@@ -91,5 +91,5 @@
             alSourcePlay(this->audioSource_);
             if (int error = alGetError())
-                COUT(2) << "Sound: Error playing sound: " << SoundManager::getALErrorString(error) << std::endl;
+                COUT(2) << "Sound: Error playing sound: " << getALErrorString(error) << std::endl;
         }
     }
@@ -141,10 +141,9 @@
         alSource3f(this->audioSource_, AL_DIRECTION, 0, 0, 0);
         if (ALint error = alGetError())
-            COUT(2) << "Sound Warning: Setting source parameters to 0 failed: "
-                    << SoundManager::getALErrorString(error) << std::endl;
+            COUT(2) << "Sound Warning: Setting source parameters to 0 failed: " << getALErrorString(error) << std::endl;
         assert(this->soundBuffer_ != NULL);
         alSourcei(this->audioSource_, AL_BUFFER, this->soundBuffer_->getBuffer());
         if (ALuint error = alGetError())
-            COUT(1) << "Sound Error: Could not set buffer \"" << this->source_ << "\": " << SoundManager::getALErrorString(error) << std::endl;
+            COUT(1) << "Sound Error: Could not set buffer \"" << this->source_ << "\": " << getALErrorString(error) << std::endl;
     }
 
@@ -164,6 +163,5 @@
             alSourcef(this->audioSource_, AL_GAIN, volume);
             if (int error = alGetError())
-                COUT(2) << "Sound: Error setting volume to " << volume
-                        << ": " << SoundManager::getALErrorString(error) << std::endl;
+                COUT(2) << "Sound: Error setting volume to " << volume << ": " << getALErrorString(error) << std::endl;
         }
     }
@@ -189,5 +187,5 @@
             alSourcef(this->audioSource_, AL_PITCH, pitch);
             if (int error = alGetError())
-                COUT(2) << "Sound: Error setting pitch: " << SoundManager::getALErrorString(error) << std::endl;
+                COUT(2) << "Sound: Error setting pitch: " << getALErrorString(error) << std::endl;
         }
     }
@@ -234,5 +232,5 @@
             if (ALuint error = alGetError())
             {
-                COUT(1) << "Sound Error: Could not set buffer \"" << source << "\": " << SoundManager::getALErrorString(error) << std::endl;
+                COUT(1) << "Sound Error: Could not set buffer \"" << source << "\": " << getALErrorString(error) << std::endl;
                 return;
             }
@@ -242,5 +240,5 @@
             alSourcePlay(this->audioSource_);
             if (int error = alGetError())
-                COUT(2) << "Sound: Error playing sound: " << SoundManager::getALErrorString(error) << std::endl;
+                COUT(2) << "Sound: Error playing sound: " << getALErrorString(error) << std::endl;
             if (this->isPaused())
                 alSourcePause(this->audioSource_);
Index: /code/branches/sound4/src/orxonox/sound/BaseSound.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/BaseSound.h	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/BaseSound.h	(revision 6435)
@@ -30,5 +30,5 @@
 #define _BaseSound_H__
 
-#include "OrxonoxPrereqs.h"
+#include "sound/SoundPrereqs.h"
 
 #include <string>
Index: /code/branches/sound4/src/orxonox/sound/SoundBuffer.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/SoundBuffer.h	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/SoundBuffer.h	(revision 6435)
@@ -30,5 +30,5 @@
 #define _SoundBuffer_H__
 
-#include "OrxonoxPrereqs.h"
+#include "sound/SoundPrereqs.h"
 
 #include <list>
Index: /code/branches/sound4/src/orxonox/sound/SoundManager.cc
===================================================================
--- /code/branches/sound4/src/orxonox/sound/SoundManager.cc	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/SoundManager.cc	(revision 6435)
@@ -52,5 +52,6 @@
     ManageScopedSingleton(SoundManager, ScopeID::Graphics, true);
 
-    std::string SoundManager::getALErrorString(ALenum code)
+    // From SoundPrereqs.h
+    std::string getALErrorString(ALenum code)
     {
         switch (code)
Index: /code/branches/sound4/src/orxonox/sound/SoundManager.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/SoundManager.h	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/SoundManager.h	(revision 6435)
@@ -31,5 +31,5 @@
 #define _SoundManager_H__
 
-#include "OrxonoxPrereqs.h"
+#include "sound/SoundPrereqs.h"
 
 #include <list>
@@ -99,6 +99,4 @@
         void releaseSoundSource(ALuint source);
 
-        static std::string getALErrorString(ALenum error);
-
     private:
         void processCrossFading(float dt);
Index: /code/branches/sound4/src/orxonox/sound/SoundPrereqs.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/SoundPrereqs.h	(revision 6435)
+++ /code/branches/sound4/src/orxonox/sound/SoundPrereqs.h	(revision 6435)
@@ -0,0 +1,70 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Reto Grieder
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+@file
+@brief
+    Enums, constants, functions and forward declarations for the sound files.
+*/
+
+#ifndef _SoundPrereqs_H__
+#define _SoundPrereqs_H__
+
+#include "OrxonoxPrereqs.h"
+
+//-----------------------------------------------------------------------
+// Forward declarations
+//-----------------------------------------------------------------------
+
+namespace orxonox
+{
+    class AmbientSound;
+    class BaseSound;
+    class SoundBuffer;
+    class SoundManager;
+    class SoundStreamer;
+    class WorldSound;
+}
+
+typedef struct ALCcontext_struct ALCcontext;
+typedef struct ALCdevice_struct ALCdevice;
+typedef unsigned int ALuint;
+typedef int ALint;
+typedef int ALenum;
+
+//-----------------------------------------------------------------------
+// Helper functions
+//-----------------------------------------------------------------------
+
+namespace orxonox
+{
+    //! Returns an error string for an AL error code
+    _OrxonoxExport std::string getALErrorString(ALenum error);
+}
+
+#endif /* _SoundPrereqs_H__ */
Index: /code/branches/sound4/src/orxonox/sound/SoundStreamer.cc
===================================================================
--- /code/branches/sound4/src/orxonox/sound/SoundStreamer.cc	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/SoundStreamer.cc	(revision 6435)
@@ -91,6 +91,5 @@
             alGetSourcei(audioSource, AL_BUFFERS_PROCESSED, &processed);
             if (ALint error = alGetError())
-            COUT(2) << "Sound Warning: Couldn't get number of processed buffers: "
-                    << SoundManager::getALErrorString(error) << std::endl;
+            COUT(2) << "Sound Warning: Couldn't get number of processed buffers: " << getALErrorString(error) << std::endl;
 
             if(processed > 0)
@@ -99,6 +98,5 @@
                 alSourceUnqueueBuffers(audioSource, processed, buffers);
                 if (ALint error = alGetError())
-                    COUT(2) << "Sound Warning: Couldn't unqueue buffers: "
-                    << SoundManager::getALErrorString(error) << std::endl;
+                    COUT(2) << "Sound Warning: Couldn't unqueue buffers: " << getALErrorString(error) << std::endl;
 
                 for(int i = 0; i < processed; i++)
@@ -121,6 +119,5 @@
                 alSourceQueueBuffers(audioSource, processed, buffers);
                 if (ALint error = alGetError())
-                    COUT(2) << "Sound Warning: Couldn't queue buffers: "
-                    << SoundManager::getALErrorString(error) << std::endl;
+                    COUT(2) << "Sound Warning: Couldn't queue buffers: " << getALErrorString(error) << std::endl;
             }
         }
Index: /code/branches/sound4/src/orxonox/sound/SoundStreamer.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/SoundStreamer.h	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/SoundStreamer.h	(revision 6435)
@@ -29,5 +29,5 @@
 #define _SoundStreamer_H__
 
-#include "OrxonoxPrereqs.h"
+#include "sound/SoundPrereqs.h"
 
 #include <string>
Index: /code/branches/sound4/src/orxonox/sound/WorldSound.h
===================================================================
--- /code/branches/sound4/src/orxonox/sound/WorldSound.h	(revision 6434)
+++ /code/branches/sound4/src/orxonox/sound/WorldSound.h	(revision 6435)
@@ -30,5 +30,5 @@
 #define _WorldSound_H__
 
-#include "OrxonoxPrereqs.h"
+#include "sound/SoundPrereqs.h"
 
 #include "tools/interfaces/Tickable.h"