Index: code/branches/network2/src/orxonox/CMakeLists.txt
===================================================================
--- code/branches/network2/src/orxonox/CMakeLists.txt	(revision 6433)
+++ code/branches/network2/src/orxonox/CMakeLists.txt	(revision 6448)
@@ -32,4 +32,5 @@
   PlayerManager.cc
   Radar.cc
+  Test.cc
 COMPILATION_BEGIN SceneCompilation.cc
   CameraManager.cc
Index: code/branches/network2/src/orxonox/Level.h
===================================================================
--- code/branches/network2/src/orxonox/Level.h	(revision 6433)
+++ code/branches/network2/src/orxonox/Level.h	(revision 6448)
@@ -46,5 +46,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             inline void setDescription(const std::string& description)
@@ -57,4 +56,5 @@
 
         private:
+            void registerVariables();
             void addObject(BaseObject* object);
             BaseObject* getObject(unsigned int index) const;
Index: code/branches/network2/src/orxonox/Test.h
===================================================================
--- code/branches/network2/src/orxonox/Test.h	(revision 6433)
+++ code/branches/network2/src/orxonox/Test.h	(revision 6448)
@@ -49,5 +49,4 @@
 
       void setConfigValues();
-      void registerVariables();
 
       static void call(unsigned int clientID);
@@ -86,4 +85,6 @@
 
     private:
+      void registerVariables();
+
       UTYPE u1;
       UTYPE u2;
Index: code/branches/network2/src/orxonox/collisionshapes/CollisionShape.h
===================================================================
--- code/branches/network2/src/orxonox/collisionshapes/CollisionShape.h	(revision 6433)
+++ code/branches/network2/src/orxonox/collisionshapes/CollisionShape.h	(revision 6448)
@@ -45,5 +45,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             inline void setPosition(const Vector3& position)
@@ -88,4 +87,6 @@
 
         private:
+            void registerVariables();
+
             Vector3                 position_;
             Quaternion              orientation_;
Index: code/branches/network2/src/orxonox/graphics/Backlight.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/Backlight.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/Backlight.h	(revision 6448)
@@ -45,5 +45,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void tick(float dt);
@@ -81,4 +80,5 @@
 
         private:
+            void registerVariables();
             virtual void startturnonoff();
             virtual void stopturnonoff();
Index: code/branches/network2/src/orxonox/graphics/Billboard.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/Billboard.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/Billboard.h	(revision 6448)
@@ -46,5 +46,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void changedVisibility();
@@ -78,4 +77,5 @@
 
         private:
+            void registerVariables();
             void changedMaterial();
 //            void changedRotation();
Index: code/branches/network2/src/orxonox/graphics/BlinkingBillboard.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/BlinkingBillboard.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/BlinkingBillboard.h	(revision 6448)
@@ -45,5 +45,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void tick(float dt);
@@ -70,4 +69,6 @@
 
         private:
+            void registerVariables();
+            
             float amplitude_;
             float frequency_;
Index: code/branches/network2/src/orxonox/graphics/FadingBillboard.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/FadingBillboard.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/FadingBillboard.h	(revision 6448)
@@ -46,5 +46,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void tick(float dt);
@@ -66,4 +65,5 @@
 
         protected:
+            void registerVariables();
             virtual void startturnonoff();
             virtual void stopturnonoff();
Index: code/branches/network2/src/orxonox/graphics/GlobalShader.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/GlobalShader.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/GlobalShader.h	(revision 6448)
@@ -45,5 +45,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void changedVisibility();
@@ -53,4 +52,5 @@
 
         private:
+            void registerVariables();
             void changedCompositor();
 
Index: code/branches/network2/src/orxonox/graphics/Light.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/Light.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/Light.h	(revision 6448)
@@ -57,5 +57,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void changedVisibility();
@@ -132,4 +131,5 @@
 
         private:
+            void registerVariables();
             void setTypeString(const std::string& type);
             std::string getTypeString() const;
Index: code/branches/network2/src/orxonox/graphics/Model.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/Model.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/Model.h	(revision 6448)
@@ -45,5 +45,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void changedVisibility();
@@ -63,4 +62,5 @@
 
         private:
+            void registerVariables();
             void changedMesh();
             void changedShadows();
Index: code/branches/network2/src/orxonox/graphics/ParticleEmitter.h
===================================================================
--- code/branches/network2/src/orxonox/graphics/ParticleEmitter.h	(revision 6433)
+++ code/branches/network2/src/orxonox/graphics/ParticleEmitter.h	(revision 6448)
@@ -44,5 +44,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void changedVisibility();
@@ -74,4 +73,7 @@
             std::string        source_;
             LODParticle::Value   LOD_;
+
+        private:
+            void registerVariables();
     };
 }
Index: code/branches/network2/src/orxonox/infos/GametypeInfo.h
===================================================================
--- code/branches/network2/src/orxonox/infos/GametypeInfo.h	(revision 6433)
+++ code/branches/network2/src/orxonox/infos/GametypeInfo.h	(revision 6448)
@@ -45,6 +45,4 @@
             virtual ~GametypeInfo();
 
-            void registerVariables();
-
             inline bool hasStarted() const
                 { return this->bStarted_; }
@@ -70,4 +68,6 @@
 
         private:
+            void registerVariables();
+
             bool bStarted_;
             bool bEnded_;
Index: code/branches/network2/src/orxonox/infos/HumanPlayer.h
===================================================================
--- code/branches/network2/src/orxonox/infos/HumanPlayer.h	(revision 6433)
+++ code/branches/network2/src/orxonox/infos/HumanPlayer.h	(revision 6448)
@@ -43,5 +43,4 @@
             virtual ~HumanPlayer();
 
-            void registerVariables();
             void setConfigValues();
 
@@ -101,4 +100,6 @@
             std::string gametypeHudTemplate_;
             OverlayGroup* gametypeHud_;
+        private:
+            void registerVariables();
     };
 }
Index: code/branches/network2/src/orxonox/infos/PlayerInfo.h
===================================================================
--- code/branches/network2/src/orxonox/infos/PlayerInfo.h	(revision 6433)
+++ code/branches/network2/src/orxonox/infos/PlayerInfo.h	(revision 6448)
@@ -42,6 +42,4 @@
             PlayerInfo(BaseObject* creator);
             virtual ~PlayerInfo();
-
-            void registerVariables();
 
             virtual void changedName();
@@ -91,4 +89,5 @@
 
         private:
+            void registerVariables();
             void networkcallback_changedcontrollableentityID();
             void networkcallback_changedgtinfoID();
Index: code/branches/network2/src/orxonox/items/Engine.h
===================================================================
--- code/branches/network2/src/orxonox/items/Engine.h	(revision 6433)
+++ code/branches/network2/src/orxonox/items/Engine.h	(revision 6448)
@@ -44,5 +44,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
             void setConfigValues();
 
@@ -107,4 +106,5 @@
 
         private:
+            void registerVariables();
             void networkcallback_shipID();
 
Index: code/branches/network2/src/orxonox/items/MultiStateEngine.h
===================================================================
--- code/branches/network2/src/orxonox/items/MultiStateEngine.h	(revision 6433)
+++ code/branches/network2/src/orxonox/items/MultiStateEngine.h	(revision 6448)
@@ -53,5 +53,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             virtual void tick(float dt);
@@ -68,4 +67,6 @@
 
         private:
+            void registerVariables();
+
             int state_;
             int oldState_;
Index: code/branches/network2/src/orxonox/worldentities/BigExplosion.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/BigExplosion.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/BigExplosion.h	(revision 6448)
@@ -45,5 +45,4 @@
 
             virtual void tick(float dt);
-            void registerVariables();
 
             inline void setLOD(LODParticle::Value level)
@@ -53,4 +52,5 @@
 
         private:
+            void registerVariables();
 
             void LODchanged();
Index: code/branches/network2/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/ControllableEntity.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/ControllableEntity.h	(revision 6448)
@@ -49,5 +49,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             virtual void tick(float dt);
-            void registerVariables();
             void setConfigValues();
 
@@ -163,4 +162,5 @@
 
         private:
+            void registerVariables();
             void setXMLController(Controller* controller);
 
Index: code/branches/network2/src/orxonox/worldentities/ExplosionChunk.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/ExplosionChunk.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/ExplosionChunk.h	(revision 6448)
@@ -44,5 +44,4 @@
 
             virtual void tick(float dt);
-            void registerVariables();
 
             inline void setLOD(LODParticle::Value level)
@@ -52,4 +51,5 @@
 
         private:
+            void registerVariables();
             void LODchanged();
             void checkStop();
Index: code/branches/network2/src/orxonox/worldentities/MobileEntity.cc
===================================================================
--- code/branches/network2/src/orxonox/worldentities/MobileEntity.cc	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/MobileEntity.cc	(revision 6448)
@@ -46,6 +46,4 @@
         this->angularAcceleration_ = Vector3::ZERO;
         this->angularVelocity_     = Vector3::ZERO;
-
-        this->registerVariables();
     }
 
Index: code/branches/network2/src/orxonox/worldentities/MovableEntity.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/MovableEntity.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/MovableEntity.h	(revision 6448)
@@ -48,5 +48,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             virtual bool collidesAgainst(WorldEntity* otherObject, btManifoldPoint& contactPoint);
-            void registerVariables();
 
             using WorldEntity::setPosition;
@@ -79,4 +78,5 @@
 
         private:
+            void registerVariables();
             void clientConnected(unsigned int clientID);
             void clientDisconnected(unsigned int clientID);
Index: code/branches/network2/src/orxonox/worldentities/StaticEntity.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/StaticEntity.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/StaticEntity.h	(revision 6448)
@@ -42,6 +42,4 @@
             virtual ~StaticEntity();
 
-            void registerVariables();
-
             using WorldEntity::setPosition;
             using WorldEntity::setOrientation;
@@ -51,4 +49,5 @@
 
         private:
+            void registerVariables();
             bool isCollisionTypeLegal(CollisionType type) const;
 
Index: code/branches/network2/src/orxonox/worldentities/WorldEntity.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/WorldEntity.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/WorldEntity.h	(revision 6448)
@@ -95,5 +95,4 @@
 
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
-            void registerVariables();
 
             inline const Ogre::SceneNode* getNode() const
@@ -212,4 +211,6 @@
 
         private:
+            void registerVariables();
+            
             inline void lookAt_xmlport(const Vector3& target)
                 { this->lookAt(target); }
Index: code/branches/network2/src/orxonox/worldentities/pawns/Pawn.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/pawns/Pawn.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/pawns/Pawn.h	(revision 6448)
@@ -49,5 +49,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             virtual void tick(float dt);
-            void registerVariables();
 
             inline bool isAlive() const
@@ -151,4 +150,5 @@
 
         private:
+            void registerVariables();
             inline void setWeaponSystem(WeaponSystem* weaponsystem)
                 { this->weaponSystem_ = weaponsystem; }
Index: code/branches/network2/src/orxonox/worldentities/pawns/SpaceShip.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/pawns/SpaceShip.h	(revision 6448)
@@ -47,5 +47,4 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             virtual void tick(float dt);
-            void registerVariables();
             void setConfigValues();
 
@@ -98,7 +97,7 @@
 
         private:
+            void registerVariables();
             virtual bool isCollisionTypeLegal(WorldEntity::CollisionType type) const;
 
-        private:
             void loadEngineTemplate();
 
Index: code/branches/network2/src/orxonox/worldentities/pawns/Spectator.h
===================================================================
--- code/branches/network2/src/orxonox/worldentities/pawns/Spectator.h	(revision 6433)
+++ code/branches/network2/src/orxonox/worldentities/pawns/Spectator.h	(revision 6448)
@@ -44,5 +44,4 @@
 
             void setConfigValues();
-            void registerVariables();
             virtual void tick(float dt);
 
@@ -63,4 +62,5 @@
 
         private:
+            void registerVariables();
             void changedGreeting();
             void changedFlareVisibility();